/*
 * adc_func.c
 *
 * implements basic adc-functions (useing internal ADC of AVR32 µC)
 *
 *  Created on: 09.03.2009
 *      Author: DO1FJN, Jan Alte
 *
 *
 * This file is part of the DV-modem firmware (DVfirmware).
 * For general infomation about DVfirmware see "dv-main.c".
 *
 * DVfirmware is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * The DVfirmware is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this package. If not, see <http://www.gnu.org/licenses/>.
 *
 */


#include "adc_func.h"
#include "hw_defs.h"
#include "compiler.h"


void adc_init(void) {
  AVR32_ADC.cr   = AVR32_ADC_SWRST_MASK;
  AVR32_ADC.chdr = 0xFF;			// Disable all CH
  AVR32_ADC.cher = ACTIVECHANNEL_MASK;
  AVR32_ADC.mr   = (ADC_SHTIM_VAL<<AVR32_ADC_SHTIM_OFFSET) |
    (ADC_STARTUP_VAL<<AVR32_ADC_STARTUP_OFFSET) |
    (((MASTERCLOCK/ADC_CLOCK+1)/2-1)<<AVR32_ADC_PRESCAL_OFFSET);
}


__inline void adc_exit(void) {
  AVR32_ADC.cr   = AVR32_ADC_SWRST_MASK;
  AVR32_ADC.chdr = 0xFF;			// Disable all CH
}


__inline void adc_startconversion(void) {
  AVR32_ADC.cr = AVR32_ADC_START_MASK;
}
