/*
 * rs232_func.h
 *
 * Simple RS232 communication routines using a fifo buffer.
 *
 *
 *  Created on: 11.08.2009
 *      Author: Jan Alte, DO1FJN
 *
 *
 * This file is part of the DV-modem firmware (DVfirmware).
 * For general infomation about DVfirmware see "dv-main.c".
 *
 * DVfirmware is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * The DVfirmware is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this package. If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef RS232_FUNC_H_
#define RS232_FUNC_H_

#define RS232_TIMEOUT		60		// Bitzeit = 6 Byte Zeit

#define RS232_RXBUFFERSIZE	2048

typedef enum {
  no_flow, xon_xoff, rts_cts, fc_reserved
} tFlowCtrl;


void	rs232_init(unsigned long baudrate, tFlowCtrl flow);
void	rs232_exit(void);
void	rs232_settimeout(unsigned long baudrate, unsigned int ms);

void	rs232_transmit(const char *data, int len);

int	rs232_received(void);		// Anzahl empfanener Bytes

void	rs232_flushrx(void);		// löscht den Inhalt des Rx

int	rs232_copyblock(char *destbuffer, int len);

#endif // RS232_FUNC_H_


