/*
 * twi_func.c
 *
 * I²C functions. This module is not completed jet! A complete version must
 * implement eeprom_read()/eeprom_write() functions (handle 24C512 eeprom).
 *
 * On HW0.9PT TWI-Write function is used to set up the digital potentiometer.
 *
 *  Created on: 08.03.2009
 *      Author: Jan Alte, DO1FJN
 *
 *
 * This file is part of the DV-modem firmware (DVfirmware).
 * For general infomation about DVfirmware see "dv-main.c".
 *
 * DVfirmware is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * The DVfirmware is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this package. If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include "twi_func.h"
#include "hw_defs.h"
#include "intc.h"

#define TWIIO	AVR32_TWI
#define TWIIRQ	AVR32_TWI_IRQ


/*! \name TWI / EE-Prom API Functions
 */
//! @{

void twi_init(void) {
  U8 twickdiv = ((MASTERCLOCK/TWICLOCK+1)/2)-4;
  // ToDo: pm_enable_TWI()...
  TWIIO.cr = AVR32_TWI_SWRST_MASK|AVR32_TWI_SVDIS_MASK;
  TWIIO.cwgr = (twickdiv << AVR32_TWI_CWGR_CHDIV_OFFSET)|(twickdiv << AVR32_TWI_CWGR_CLDIV_OFFSET);
  TWIIO.cr = AVR32_TWI_MSEN_MASK;
}


void twi_exit(void) {
  TWIIO.cr = AVR32_TWI_SWRST_MASK|AVR32_TWI_SVDIS_MASK;
  // ToDo: pm_disable_TWI() ...
}


void twi_write(char adr, const unsigned char *data, unsigned short int len) {
  U32 twista;
  TWIIO.mmr = ((adr&0x7F)<<AVR32_TWI_MMR_DADR_OFFSET);	// MREAD=0, IADRZ=0 (no int. adr)
  while (len > 0) {
    if (len==1) TWIIO.cr |= AVR32_TWI_CR_STOP_MASK;
    TWIIO.thr = *data++;
    len--;
    do {
      twista = TWIIO.sr;
    } while ((twista&AVR32_TWI_SR_TXRDY_MASK)==0);
  }
  while ((TWIIO.sr&AVR32_TWI_SR_TXCOMP_MASK)==0) { }	// Warte Finish
}

//! @}

